summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2020-12-25 21:21:23 +0000
committer Eric Hameleers <alien@slackware.com>2020-12-25 21:21:23 +0000
commitebeb9db52af472444de7795f7ddb2f379ce71656 (patch)
treecb35a62deaeb48c42d9120e1cd7efeb031cd5e18
parent08d91295aa03e94409ad90fabb9b8639acb9aae6 (diff)
downloadasb-ebeb9db52af472444de7795f7ddb2f379ce71656.tar.gz
asb-ebeb9db52af472444de7795f7ddb2f379ce71656.tar.xz
Initial revision
-rwxr-xr-xglfw/build/glfw.SlackBuild205
-rw-r--r--glfw/build/slack-desc19
-rw-r--r--vcvrack/build/patches/vcvrack-1.1.6_devendor.patch223
-rw-r--r--vcvrack/build/patches/vcvrack-1.1.6_no_pffft_dl.patch30
-rw-r--r--vcvrack/build/slack-desc19
-rw-r--r--vcvrack/build/slack-required5
-rwxr-xr-xvcvrack/build/vcvrack.SlackBuild381
7 files changed, 882 insertions, 0 deletions
diff --git a/glfw/build/glfw.SlackBuild b/glfw/build/glfw.SlackBuild
new file mode 100755
index 00000000..eda98949
--- /dev/null
+++ b/glfw/build/glfw.SlackBuild
@@ -0,0 +1,205 @@
+#!/bin/sh
+# $Id$
+# Copyright 2020 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: glfw
+# Descr: portable framework for GUI development
+# URL: http://www.glfw.org/
+# Build needs:
+# Needs:
+# Changelog:
+# 3.3.2-1: 25/Dec/2020 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh glfw.SlackBuild' to build a Slackware package.
+# The package (.t?z) and .txt file as well as build logs are created in /tmp .
+# Install the package using 'installpkg' or 'upgradepkg --install-new'.
+#
+# -----------------------------------------------------------------------------
+
+PRGNAM=glfw
+VERSION=${VERSION:-3.3.2}
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:-" -j$(nproc) "}
+TAG=${TAG:-alien}
+
+DOCS="LICENSE.md README.md"
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE="$SRCDIR/${PRGNAM}-${VERSION}.tar.gz"
+SRCURL="https://github.com/${PRGNAM}/${PRGNAM}/archive/${VERSION}.tar.gz"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i586 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+fi
+# Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
+case "$ARCH" in
+ i?86) SLKCFLAGS="-O2 -march=${ARCH} -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ armv7hl) SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ *) SLKCFLAGS=${SLKCFLAGS:-"-O2"}
+ SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+ ;;
+esac
+
+case "$ARCH" in
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{checkout,configure,make,install,error,makepkg,patch}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
+ if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE)"
+ wget --no-check-certificate -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE})' not available... aborting the build."
+ exit 1
+ fi
+fi
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE}
+cd ${PRGNAM}-${VERSION}
+chown -R root:root .
+chmod -R u+w,go+r-w,a+rX-st .
+
+echo Building ...
+mkdir -p build-${PRGNAM}
+cd build-${PRGNAM}
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+ -DCMAKE_BUILD_TYPE=Release \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DCMAKE_INSTALL_LIBDIR=lib${LIBDIRSUFFIX} \
+ -DCMAKE_INSTALL_MANDIR=/usr/man \
+ -DCMAKE_INSTALL_SYSCONFDIR=/etc \
+ -DBUILD_SHARED_LIBS=ON \
+ ..
+ make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+ make DESTDIR=$PKG install 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
+cd -
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+
+# Restore the original umask:
+umask ${_UMASK_}
+
diff --git a/glfw/build/slack-desc b/glfw/build/slack-desc
new file mode 100644
index 00000000..15972095
--- /dev/null
+++ b/glfw/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+glfw: glfw (portable framework for GUI development)
+glfw:
+glfw: GLFW is an Open Source, multi-platform library for OpenGL, OpenGL ES
+glfw: and Vulkan development on the desktop.
+glfw: It provides a simple API for creating windows, contexts and surfaces,
+glfw: receiving input and events.
+glfw: GLFW is written in C and supports Windows, macOS, X11 and Wayland.
+glfw:
+glfw:
+glfw: See also: http://www.glfw.org/
+glfw:
diff --git a/vcvrack/build/patches/vcvrack-1.1.6_devendor.patch b/vcvrack/build/patches/vcvrack-1.1.6_devendor.patch
new file mode 100644
index 00000000..98754070
--- /dev/null
+++ b/vcvrack/build/patches/vcvrack-1.1.6_devendor.patch
@@ -0,0 +1,223 @@
+From c74ada5fa42de4947eb0d65886f21528b8e65be7 Mon Sep 17 00:00:00 2001
+From: David Runge <dave@sleepmap.de>
+Date: Sat, 6 Jul 2019 12:01:35 +0200
+Subject: [PATCH] Makefile: Setting VERSION from the environment if set, else
+ default back to old behavior of VERSION composition. Using the environment
+ variable USE_SYSTEM_LIBS to devendor all unnecessarily static libraries
+ (curl, glew, jansson, speexdsp, libzip, openssl, rtaudio, rtmidi) and using
+ pkg-config to retrieve the location of the ones already dynamically linked
+ (alsa, gtk+-2.0, jack, x11). compile.mk: Exporting CFLAGS of glew, jansson,
+ libcurl, libzip, openssl, rtaudio, rtmidi and speexdsp (using pkg-config) to
+ FLAGS (which will be used in CFLAGS and CXXFLAGS). dep.mk: Exporting CFLAGS
+ of glew, jansson, libcurl, libzip, openssel, rtaudio, rtmidi and speexdsp
+ (using pkg-config) to DEP_FLAGS (which will be used in CLFAGS and CXXFLAGS of
+ the dependencies). dep/Makefile: When using USE_SYSTEM_LIBS, shrinking the
+ statically linked libraries down to the vendored glfw3 (which is in use
+ because of one single, not upstreamed, custom function). This eliminates the
+ vendored glew, speexdsp, openssl, curl, libzip, zlib, rtaudio, rtmidi and
+ only leaves the vendored glfw, nanovg, nanosvgg, oui-blendish, osdialog and
+ pffft. Makefile: Removing VERSION hardcoding (per release). src/main.cpp:
+ Removing call to glfwGetOpenedFilename() (which is a hacky addition to gflw
+ only for macOS: https://github.com/AndrewBelt/glfw/pull/1 ). Makefile,
+ dep.mk, dep/Makefile: Devendoring gflw, if USE_SYSTEM_LIBS is used.
+
+dep/Makefile: Making sure to create the dep/include directory, before copying files to it. Removing dead code.
+---
+ Makefile | 11 +++++++-
+ compile.mk | 4 +++
+ dep.mk | 4 +++
+ dep/Makefile | 57 +++++++++++++++++++++++++++++-----------
+ src/app/ModuleWidget.cpp | 2 +-
+ 5 files changed, 60 insertions(+), 18 deletions(-)
+
+diff --git a/Makefile b/Makefile
+index bd1d631a..2108cd5c 100644
+--- a/Makefile
++++ b/Makefile
+@@ -1,7 +1,10 @@
+ RACK_DIR ?= .
+-# VERSION := 1.dev.$(shell git rev-parse --short HEAD)
+ VERSION := 1.1.6
+
++ifeq ($(strip $(VERSION)),)
++VERSION := 1.dev.$(shell git rev-parse --short HEAD)
++endif
++
+ FLAGS += -DVERSION=$(VERSION)
+ FLAGS += -Iinclude -Idep/include
+
+@@ -20,10 +23,16 @@ ifdef ARCH_LIN
+ SOURCES += dep/osdialog/osdialog_gtk2.c
+ build/dep/osdialog/osdialog_gtk2.c.o: FLAGS += $(shell pkg-config --cflags gtk+-2.0)
+
++ifneq ($(USE_SYSTEM_LIBS),true)
+ LDFLAGS += -rdynamic \
+ dep/lib/libGLEW.a dep/lib/libglfw3.a dep/lib/libjansson.a dep/lib/libcurl.a dep/lib/libssl.a dep/lib/libcrypto.a dep/lib/libzip.a dep/lib/libz.a dep/lib/libspeexdsp.a dep/lib/libsamplerate.a dep/lib/librtmidi.a dep/lib/librtaudio.a \
+ -lpthread -lGL -ldl -lX11 -lasound -ljack \
+ $(shell pkg-config --libs gtk+-2.0)
++else
++ LDFLAGS += -rdynamic \
++ -lpthread -ldl \
++ $(shell pkg-config --libs alsa glew glfw3 gtk+-2.0 jack jansson libcurl libzip zlib openssl rtaudio rtmidi speexdsp x11)
++endif
+ TARGET := Rack
+ endif
+
+diff --git a/compile.mk b/compile.mk
+index 96ea4b8d..0febe00c 100644
+--- a/compile.mk
++++ b/compile.mk
+@@ -18,6 +18,10 @@ FLAGS += -Wall -Wextra -Wno-unused-parameter
+ # C++ standard
+ CXXFLAGS += -std=c++11
+
++ifeq ($(USE_SYSTEM_LIBS),true)
++FLAGS += $(shell pkg-config --cflags glew jansson libcurl libzip openssl rtaudio rtmidi speexdsp)
++endif
++
+ # Architecture-independent flags
+ ifdef ARCH_LIN
+ FLAGS += -DARCH_LIN
+diff --git a/dep.mk b/dep.mk
+index bad90ec7..b0eb59d6 100644
+--- a/dep.mk
++++ b/dep.mk
+@@ -7,6 +7,10 @@ DEP_PATH := $(abspath $(DEP_LOCAL))
+
+ DEP_FLAGS += -g -O3 -march=nocona
+
++ifeq ($(USE_SYSTEM_LIBS),true)
++DEP_FLAGS += $(shell pkg-config --cflags glew glfw3 jansson libcurl libzip openssl rtaudio rtmidi speexdsp)
++endif
++
+ ifeq ($(ARCH), mac)
+ DEP_MAC_SDK_FLAGS := -mmacosx-version-min=10.7
+ DEP_FLAGS += $(DEP_MAC_SDK_FLAGS) -stdlib=libc++
+diff --git a/dep/Makefile b/dep/Makefile
+index 4ce54ad5..ed9381bb 100755
+--- a/dep/Makefile
++++ b/dep/Makefile
+@@ -6,6 +6,7 @@ RACK_DIR ?= ..
+
+ include $(RACK_DIR)/arch.mk
+
++ifneq ($(USE_SYSTEM_LIBS),true)
+ ifdef ARCH_LIN
+ glew = lib/libGLEW.a
+ glfw = lib/libglfw3.a
+@@ -48,27 +49,29 @@ ifdef ARCH_WIN
+ rtaudio = lib/librtaudio.a
+ endif
+
++else
++
++ifdef ARCH_MAC
++ glfw = lib/libglfw3.a
++endif
++
++ifdef ARCH_WIN
++ glfw = lib/libglfw3.a
++endif
++
++endif
++
+ nanovg = include/nanovg.h
+ nanosvg = include/nanosvg.h
+ oui-blendish = include/blendish.h
+ osdialog = include/osdialog.h
+ pffft = include/pffft.h
+
+-DEPS += $(glew)
+-DEPS += $(glfw)
+-DEPS += $(jansson)
+-DEPS += $(libcurl)
+-DEPS += $(libzip)
+-DEPS += $(libspeexdsp)
+-DEPS += $(libsamplerate)
+-DEPS += $(rtmidi)
+-DEPS += $(rtaudio)
+-DEPS += $(nanovg)
+-DEPS += $(nanosvg)
+-DEPS += $(oui-blendish)
+-DEPS += $(osdialog)
+-DEPS += $(pffft)
+-
++ifneq ($(USE_SYSTEM_LIBS),true)
++DEPS += $(glew) $(glfw) $(jansson) $(libspeexdsp) $(libcurl) $(libzip) $(rtmidi) $(rtaudio) $(nanovg) $(nanosvg) $(oui-blendish) $(osdialog) $(pffft)
++else
++DEPS += $(nanovg) $(nanosvg) $(oui-blendish) $(osdialog) $(pffft)
++endif
+
+ DEP_LOCAL := .
+ include $(RACK_DIR)/dep.mk
+@@ -76,6 +79,7 @@ include $(RACK_DIR)/dep.mk
+
+ # Targets
+
++ifneq ($(USE_SYSTEM_LIBS),true)
+ glew-2.1.0:
+ $(WGET) "https://github.com/nigels-com/glew/releases/download/glew-2.1.0/glew-2.1.0.tgz"
+ $(SHA256) glew-2.1.0.tgz 04de91e7e6763039bc11940095cd9c7f880baba82196a7765f727ac05a993c95
+@@ -222,17 +226,31 @@ $(rtaudio): rtaudio
+ cd rtaudio/build && $(CMAKE) $(RTAUDIO_FLAGS) ..
+ $(MAKE) -C rtaudio/build
+ $(MAKE) -C rtaudio/build install
++else
++ifndef ARCH_LIN
++$(glfw): glfw
++ cd glfw && mkdir -p build
++ cd glfw/build && $(CMAKE) .. \
++ -DGLFW_BUILD_EXAMPLES=OFF -DGLFW_BUILD_TESTS=OFF -DGLFW_BUILD_DOCS=OFF
++ $(MAKE) -C glfw/build
++ $(MAKE) -C glfw/build install
++endif
++endif
+
+ $(nanovg): $(wildcard nanovg/src/*.h) nanovg/example/stb_image_write.h
++ mkdir -p include
+ cp $^ include/
+
+ $(nanosvg): $(wildcard nanosvg/src/*.h)
++ mkdir -p include
+ cp $^ include/
+
+ $(oui-blendish): $(wildcard oui-blendish/*.h)
++ mkdir -p include
+ cp $^ include/
+
+ $(osdialog): $(wildcard osdialog/*.h)
++ mkdir -p include
+ cp $^ include/
+
+ jpommier-pffft-29e4f76ac53b:
+@@ -242,11 +260,18 @@ jpommier-pffft-29e4f76ac53b:
+ rm 29e4f76ac53b.zip
+
+ $(pffft): jpommier-pffft-29e4f76ac53b
++ mkdir -p include
+ cp jpommier-pffft-29e4f76ac53b/*.h include/
+
+ # Helpers
+
+-src: glew-2.1.0 glfw jansson-2.12 speexdsp-SpeexDSP-1.2rc3 openssl-1.1.1d curl-7.66.0 libzip-1.5.2 zlib-1.2.11 rtmidi-4.0.0 rtaudio nanovg nanosvg oui-blendish osdialog jpommier-pffft-29e4f76ac53b
++ifneq ($(USE_SYSTEM_LIBS),true)
++SRC = glew-2.1.0 glfw jansson-2.12 speexdsp-SpeexDSP-1.2rc3 openssl-1.1.1b curl-7.66.0 libzip-1.5.2 zlib-1.2.11 rtmidi-4.0.0 rtaudio nanovg nanosvg oui-blendish osdialog jpommier-pffft-29e4f76ac53b
++else
++SRC = nanovg nanosvg oui-blendish osdialog jpommier-pffft-29e4f76ac53b
++endif
++
++src: $(SRC)
+
+ clean:
+ git clean -fdx
+diff --git a/src/app/ModuleWidget.cpp b/src/app/ModuleWidget.cpp
+index 998ac245..4a525e31 100644
+--- a/src/app/ModuleWidget.cpp
++++ b/src/app/ModuleWidget.cpp
+@@ -845,4 +845,4 @@ void ModuleWidget::createContextMenu() {
+
+
+ } // namespace app
+-} // namespace rack
+\ No newline at end of file
++} // namespace rack
diff --git a/vcvrack/build/patches/vcvrack-1.1.6_no_pffft_dl.patch b/vcvrack/build/patches/vcvrack-1.1.6_no_pffft_dl.patch
new file mode 100644
index 00000000..2c104f24
--- /dev/null
+++ b/vcvrack/build/patches/vcvrack-1.1.6_no_pffft_dl.patch
@@ -0,0 +1,30 @@
+diff -uarN Rack-1.1.6.orig/dep/Makefile Rack-1.1.6/dep/Makefile
+--- Rack-1.1.6.orig/dep/Makefile 2020-12-25 20:41:13.784430431 +0100
++++ Rack-1.1.6/dep/Makefile 2020-12-25 20:42:55.300566986 +0100
+@@ -253,22 +253,15 @@
+ mkdir -p include
+ cp $^ include/
+
+-jpommier-pffft-29e4f76ac53b:
+- $(WGET) "https://bitbucket.org/jpommier/pffft/get/29e4f76ac53b.zip"
+- $(SHA256) 29e4f76ac53b.zip bb10afba127904a0c6c553fa445082729b7d72373511bda1b12a5be0e03f318a
+- $(UNZIP) 29e4f76ac53b.zip
+- rm 29e4f76ac53b.zip
+-
+-$(pffft): jpommier-pffft-29e4f76ac53b
+- mkdir -p include
+- cp jpommier-pffft-29e4f76ac53b/*.h include/
++$(pffft):
++ echo
+
+ # Helpers
+
+ ifneq ($(USE_SYSTEM_LIBS),true)
+-SRC = glew-2.1.0 glfw jansson-2.12 speexdsp-SpeexDSP-1.2rc3 openssl-1.1.1b curl-7.66.0 libzip-1.5.2 zlib-1.2.11 rtmidi-4.0.0 rtaudio nanovg nanosvg oui-blendish osdialog jpommier-pffft-29e4f76ac53b
++SRC = glew-2.1.0 glfw jansson-2.12 speexdsp-SpeexDSP-1.2rc3 openssl-1.1.1b curl-7.66.0 libzip-1.5.2 zlib-1.2.11 rtmidi-4.0.0 rtaudio nanovg nanosvg oui-blendish osdialog $(wildcard jpommier-pffft-*)
+ else
+-SRC = nanovg nanosvg oui-blendish osdialog jpommier-pffft-29e4f76ac53b
++SRC = nanovg nanosvg oui-blendish osdialog $(wildcard jpommier-pffft)
+ endif
+
+ src: $(SRC)
diff --git a/vcvrack/build/slack-desc b/vcvrack/build/slack-desc
new file mode 100644
index 00000000..badeb488
--- /dev/null
+++ b/vcvrack/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+vcvrack: vcvrack (eurorack simulator)
+vcvrack:
+vcvrack: VCV Rack is a software emulation of modular synthesizers, that allows
+vcvrack: for a performance workflow like in real life, where patches are made
+vcvrack: adding modules and connecting them with patch chords.
+vcvrack: The Rack is extensible with a library of community-built modules.
+vcvrack:
+vcvrack:
+vcvrack:
+vcvrack: vcvrack home: https://vcvrack.com/
+vcvrack:
diff --git a/vcvrack/build/slack-required b/vcvrack/build/slack-required
new file mode 100644
index 00000000..3dd1fa46
--- /dev/null
+++ b/vcvrack/build/slack-required
@@ -0,0 +1,5 @@
+glfw
+jack2
+jq
+rtaudio
+rtmidi
diff --git a/vcvrack/build/vcvrack.SlackBuild b/vcvrack/build/vcvrack.SlackBuild
new file mode 100755
index 00000000..3503520f
--- /dev/null
+++ b/vcvrack/build/vcvrack.SlackBuild
@@ -0,0 +1,381 @@
+#!/bin/sh
+# $Id$
+# Copyright 2020 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: vcvrack
+# Descr: eurorack simulator
+# URL: https://vcvrack.com/
+# Build needs:
+# Needs: glfw, jack2, jq, rtaudio, rtmidi
+# Changelog:
+# 1.1.6-1: 25/Dec/2020 by Eric Hameleers <alien@slackware.com>
+# * Initial build, includes one required plugin 'Fundamental'.
+#
+# Run 'sh vcvrack.SlackBuild' to build a Slackware package.
+# The package (.t?z) and .txt file as well as build logs are created in /tmp .
+# Install the package using 'installpkg' or 'upgradepkg --install-new'.
+#
+# -----------------------------------------------------------------------------
+
+PRGNAM=vcvrack
+SRCNAM=Rack
+VERSION=${VERSION:-1.1.6}
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:-" -j$(nproc) "}
+TAG=${TAG:-alien}
+
+DOCS="CHANGELOG.md LICENSE* README.md"
+DOCS_FUNDAMENTAL="CHANGELOG.md LICENSE* README.md"
+
+PFFFT="74d7261be17c"
+PLUGIN_FUNDAMENTAL="1.3.1"
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE[0]="$SRCDIR/${SRCNAM}-${VERSION}.tar.gz"
+SRCURL[0]=""
+#SRCURL[0]="https://github.com/VCVRack/${SRCNAM}/archive/v${VERSION}.tar.gz"
+
+# We retrieve Rack plus internal deps from git:
+GITURI="git://github.com/VCVRack/${SRCNAM}.git"
+BRANCH="1.0"
+GITTAG=v$VERSION
+
+SOURCE[1]="$SRCDIR/jpommier-pffft-${PFFFT}.zip"
+SRCURL[1]="https://bitbucket.org/jpommier/pffft/get/${PFFFT}.zip"
+
+SOURCE[2]="$SRCDIR/Fundamental-${PLUGIN_FUNDAMENTAL}.tar.gz"
+SRCURL[2]="https://github.com/VCVRack/Fundamental/archive/v${PLUGIN_FUNDAMENTAL}.tar.gz"
+
+# Use the src_checkout() function if no downloadable tarball exists.
+# Check out sources from GIT and create a tarball of them.
+src_checkout() {
+ # Param #1 : index in the SOURCE[] array.
+ # Param #2 : full path to where SOURCE[$1] tarball should be created.
+ # Determine the tarball extension:
+ PEXT=$(echo "${2}" | sed -r -e 's/.*[^.].(tar.xz|tar.gz|tar.bz2|tgz).*/\1/')
+ case "$PEXT" in
+ "tar.xz") TARCOMP="J" ;;
+ "tar.gz") TARCOMP="z" ;;
+ "tgz") TARCOMP="z" ;;
+ "tar.bz2") TARCOMP="j" ;;
+ *) echo "Archive can only have extension 'tar.xz', '.tar.gz' '.tar.bz2' or '
+.tgz'" ; exit 1 ;;
+ esac
+ # Determine the directory name to create for the archive root:
+ PBASE=$(basename ${2} .${PEXT})
+ # Determine the directory where we create our checkout:
+ CODIR=$(dirname ${2})
+ case ${1} in
+ 0) RETDIR=$(pwd)
+ mkdir -p $CODIR/${PRGNAM}_temp_checkout_$$ \
+ && cd $CODIR/${PRGNAM}_temp_checkout_$$
+ mkdir ${PBASE} \
+ && cd ${PBASE}
+ echo "Checking out '$GITURI':"
+ git clone ${GITURI} . \
+ && git checkout tags/$GITTAG -b $BRANCH \
+ && git submodule update --init --recursive \
+ && chown -R root:root . \
+ && cd .. \
+ && tar --exclude .git -${TARCOMP}cf ${2} ${PBASE}
+ cd $RETDIR
+ rm -rf $CODIR/${PRGNAM}_temp_checkout_$$ || true
+ ;;
+ *) # Do nothing
+ ;;
+ esac
+}
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i586 ;;
+ arm*) readelf /usr/bin/file -A | egrep -q "Tag_CPU.*[4,5]" && ARCH=arm || ARCH=armv7hl ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) ARCH=$(uname -m) ;;
+ esac
+ export ARCH
+fi
+# Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
+case "$ARCH" in
+ i?86) SLKCFLAGS="-O2 -march=${ARCH} -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ armv7hl) SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ *) SLKCFLAGS=${SLKCFLAGS:-"-O2"}
+ SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+ ;;
+esac
+
+case "$ARCH" in
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{checkout,configure,make,install,error,makepkg,patch}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
+ if ! [ -f ${SOURCE[$i]} ]; then
+ echo "Source '$(basename ${SOURCE[$i]})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE[$i]="$OUTPUT/$(basename ${SOURCE[$i]})"
+ if [ -f ${SOURCE[$i]} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL[$i]}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE[$i])"
+ wget --no-check-certificate -nv -T 20 -O "${SOURCE[$i]}" "${SRCURL[$i]}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE[$i]}" ]; then
+ echo "Fail to download '$(basename ${SOURCE[$i]})'. Aborting the build."
+ mv -f "${SOURCE[$i]}" "${SOURCE[$i]}".FAIL
+ exit 1
+ fi
+ else
+ # Try if we have a SVN/CVS download routine for ${SOURCE[$i]}
+ echo "Will checkout sources to $(dirname $SOURCE[$i])"
+ src_checkout $i "${SOURCE[$i]}" \
+ 2>&1 > $OUTPUT/checkout-$(basename ${SOURCE[$i]}).log
+ fi
+ if [ ! -f "${SOURCE[$i]}" -o ! -s "${SOURCE[$i]}" ]; then
+ echo "File '$(basename ${SOURCE[$i]})' not available. Aborting the build."
+ exit 1
+ fi
+ fi
+done
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
+ if $(file ${SOURCE[$i]} | grep -qi ": zip"); then
+ unzip ${SOURCE[$i]}
+ else
+ tar -xvf ${SOURCE[$i]}
+ fi
+done
+
+cd ${SRCNAM}-${VERSION}
+
+# Use system libraries where possible;
+touch $OUTPUT/patch-${PRGNAM}.log
+# patch obtained from https://github.com/flying-sheep/Rack/commit/c74ada5fa42de4947eb0d65886f21528b8e65be7.patch:
+cat $SRCDIR/patches/vcvrack-1.1.6_devendor.patch | patch -p1 --verbose \
+ 2>&1 | tee -a $OUTPUT/patch-${PRGNAM}.log
+
+# We handle jpommier's pffft since the Makefile wants a hard-coded snapshot
+# which is no longer available for download:
+cat $SRCDIR/patches/vcvrack-1.1.6_no_pffft_dl.patch | patch -p1 --verbose \
+ 2>&1 | tee -a $OUTPUT/patch-${PRGNAM}.log
+
+# Do the part which we just patched out:
+mv -i ../jpommier-pffft-* dep/
+mkdir -p dep/include
+cp -ia dep/jpommier-pffft-*/*.h dep/include/
+
+# USe GTK3 instead of GTK2:
+sed -i Makefile \
+ -e 's/osdialog_gtk2/osdialog_gtk3/' -e 's/gtk+-2\.0/gtk+-3.0/'
+
+chown -R root:root .
+chmod -R u+w,go+r-w,a+rX-st .
+
+echo Building ...
+export LDFLAGS="$SLKLDFLAGS"
+export CXXFLAGS="$SLKCFLAGS"
+export CFLAGS="$SLKCFLAGS"
+make dep $NUMJOBS USE_SYSTEM_LIBS=true 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+make $NUMJOBS USE_SYSTEM_LIBS=true 2>&1 | tee -a $OUTPUT/make-${PRGNAM}.log
+
+# Install the lot manually, developers won't add an 'install' target, but
+# we can guess what goes where by looking at the VCV binary distribution/SDK:
+mkdir -p $PKG/usr/share/$PRGNAM
+# First the main program:
+install -D -m 0755 $SRCNAM -t $PKG/usr/share/$PRGNAM
+install -D -m 0644 template.vcv -t $PKG/usr/share/$PRGNAM
+install -D -m 0644 Core.json -t $PKG/usr/share/$PRGNAM
+install -D -m 0644 cacert.pem -t $PKG/usr/share/$PRGNAM
+
+# Next its resources:
+cp -a res $PKG/usr/share/$PRGNAM/
+
+# You need the following for compiling plugins:
+# Program headers:
+for INCDIR in {app,dsp,engine,plugin,simd,ui,widget}; do
+ install -D -m 0644 include/$INCDIR/* \
+ -t $PKG/usr/include/$PRGNAM/$INCDIR/
+done
+install -D -m 0644 include/*.{h,hpp} -t $PKG/usr/include/$PRGNAM/
+install -D -m 0644 dep/include/*.h -t $PKG/usr/include/$PRGNAM/dep/
+
+# Makefiles required when compiling plugins:
+install -D -m 0644 {arch,compile,dep,plugin}.mk -t $PKG/usr/share/$PRGNAM/
+
+# Helper script for plugins:
+install -D -m 0644 helper.py -t $PKG/usr/share/$PRGNAM/
+
+# Add a startup script to run the program in its own directory:
+mkdir -p $PKG/usr/bin/
+cat <<EOT > $PKG/usr/bin/${SRCNAM}
+#!/bin/sh
+cd /usr/share/${PRGNAM}
+./${SRCNAM} "\$@"
+EOT
+chmod 0755 $PKG/usr/bin/${SRCNAM}
+
+# Build the Fundamental plugin. Without this, Rack will show errors on startup:
+( cd $TMP/tmp-$PRGNAM/Fundamental-${PLUGIN_FUNDAMENTAL}
+ export RACK_DIR=$PKG//usr/share/$PRGNAM
+ export FLAGS="-I$PKG/usr/include/$PRGNAM -I$PKG/usr/include/$PRGNAM/dep"
+ # Add libsamplerate libs to the LDFLAGS:
+ export LDFLAGS="$(pkg-config --libs samplerate) ${SLKLDFLAGS}"
+ make $NUMJOBS USE_SYSTEM_LIBS=true \
+ 2>&1 | tee $OUTPUT/make-${PRGNAM}_fundamental.log
+ # Create the .zip file:
+ USE_SYSTEM_LIBS=true make dist $NUMJOBS USE_SYSTEM_LIBS=true \
+ 2>&1 | tee -a $OUTPUT/make-${PRGNAM}_fundamental.log
+ # Install the .zip file:
+ install -D -m 0644 dist/Fundamental*.zip \
+ $PKG/usr/share/$PRGNAM/Fundamental.zip
+ # Install the plugin docs:
+ mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION/Fundamental
+ cp -a ${DOCS_FUNDAMENTAL} $PKG/usr/doc/$PRGNAM-$VERSION/Fundamental/
+) || exit 1
+
+# Add a menu entry:
+mkdir -p $PKG/usr/share/applications
+cat <<EOT >$PKG/usr/share/applications/${PRGNAM}.desktop
+[Desktop Entry]
+Name=VCV Rack
+Comment=Virtual modular synthesizer
+Exec=Rack
+Terminal=false
+Type=Application
+Categories=X-DAW;Application;AudioVideo;Audio
+Icon=Rack
+EOT
+
+# The icon for the menu entry:
+install -D -m 0644 res/icon.png $PKG/usr/share/pixmaps/${SRCNAM}.png
+
+# Add this to the doinst.sh:
+mkdir -p $PKG/install
+cat <<EOINS >> $PKG/install/doinst.sh
+# Update the desktop database:
+if [ -x usr/bin/update-desktop-database ]; then
+ chroot . /usr/bin/update-desktop-database usr/share/applications > /dev/null 2>&1
+fi
+
+# Update hicolor theme cache:
+if [ -d usr/share/icons/hicolor ]; then
+ if [ -x /usr/bin/gtk-update-icon-cache ]; then
+ chroot . /usr/bin/gtk-update-icon-cache -f -t usr/share/icons/hicolor 1> /dev/null 2> /dev/null
+ fi
+fi
+
+# Update the mime database:
+if [ -x usr/bin/update-mime-database ]; then
+ chroot . /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
+fi
+
+EOINS
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+cat $SRCDIR/slack-required > $PKG/install/slack-required
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-txz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep
+
+# Restore the original umask:
+umask ${_UMASK_}
+